// ---------------------------------------------------------------------------
// drop_ammo.cs -- Version 1.4 -- December 9, 2000
// by Lorne Laliberte (writer@planetstarsiege.com)
//
// Drop any ammo you don't need (don't have a weapon for)
//
// http://www.writerscripts.com
// ---------------------------------------------------------------------------

include("writer\\version.cs");
version("writer\\drop_ammo.cs", "1.4", "Lorne Laliberte", "Dec 9, 2000");

include("writer\\inventory.cs");
include("writer\\save.cs");

// ---------------------------------------------------------------------------
// DEFAULT SETTINGS:
//
// Edit these if you're running this script for the first time
// All subsequent settings must be done in the config\wp_drop_ammo.cs file

    // Drop grenades and mines if they aren't in your current FastFaves loadout
    $DropGrenadesAndMines = "false";

    // Drop unnecessary ammo
    //bind(keyboard0, make, r_alt, "n", to, "dropUnnecessaryAmmo();");
    //bind(keyboard0, break, r_alt, "n", to, "", "dropUnnecessaryAmmo_break");

// ---------------------------------------------------------------------------

WriterPrefs::load("drop_ammo");

// Drop any ammo we're carrying if we aren't carrying a weapon that needs it
//
function dropUnnecessaryAmmo()
{
    for(%i = 1; %i <= $Inv::WeaponCount; %i++)
    {
        %type = $Inv::WeaponList[%i];
        %ammo = $Inv::Ammo[%type];
        
        if(%ammo != "") // this item (weapon) can use ammo
        {
            if(!getItemCount($Inv::Name[%type])) // we don't have this weapon
            {
                // Drop this unnecessary ammo
                if(getItemCount(%ammo))
                {
                    for(%i = 0; %i < 20; %i++)
                        drop(%ammo);
                }
            }
        }
    }

    if($DropGrenadesAndMines)
    {
        // note -- loops might not be necessary...need to test
        if(!$FastFaves::grenades)
        {
            if(getItemCount("Grenade"))
            {
                for(%i = 0; %i < 3; %i++)
                    drop("Grenade");
            }
        }
        if(!$FastFaves::mines)
        {
            if(getItemCount("Mine"))
            {
                for(%i = 0; %i < 3; %i++)
                    drop("Mine");
            }
        }
    }

}

function drop_ammo::save()
{
    AddExportText("    // Drop grenades and mines if they aren't in your current FastFaves loadout");
    ExportSetting("    $DropGrenadesAndMines", "false");

    AddExportText("");
    AddExportText("    // Drop unnecessary ammo");

    ExportBind("dropUnnecessaryAmmo();", "//bind(keyboard0, make, r_alt, \"n\", TO, \"dropUnnecessaryAmmo();\");");
    ExportBind("dropUnnecessaryAmmo_break", "//bind(keyboard0, break, r_alt, \"n\", TO, \"\", dropUnnecessaryAmmo_break);");
}

WriterPrefs::save("drop_ammo");

function drop_ammo::init()
{
    needs("writer\\drop_ammo.cs", "writer\\inventory.cs 3.3",
                                  "writer\\save.cs 2.3");

    if($DropGrenadesAndMines)
        wants("writer\\drop_ammo.cs", "writer\\fast_faves.cs 7.6");
}
Event::Attach(writerInit, "drop_ammo::init();");

if(!$UsingWriterLoader) drop_ammo::init();
